using Stun2DPhysics4SL.Mathematics;
using System;

namespace Stun2DPhysics4SL.Dynamics
{
    /// <summary>
    /// Body: λáٶȡٶȵ...
    /// </summary>
    public sealed class Body
    {
        /// <summary>
        /// һθʱٶ
        /// </summary>
        private Vector2 previousLinearVelocity = Vector2.Zero;

        /// <summary>
        /// һθʱλ
        /// </summary>
        private Vector2 previousPosition = Vector2.Zero;

        /// <summary>
        /// Bodyĵǰλ
        /// </summary>
        internal Vector2 position = Vector2.Zero;

        /// <summary>
        /// BodyǷֹ
        /// </summary>
        internal bool isStatic;

        /// <summary>
        /// ȡĵٶȡ
        /// </summary>
        public Vector2 LinearVelocity = Vector2.Zero;

        internal float mass = 1;
        internal float inverseMass = 1;
        internal Vector2 force = Vector2.Zero;

        /// <summary>
        /// һBody
        /// </summary>
        public Body() { }

        /// <summary>
        /// ȡBodyλá
        /// </summary>
        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }

        /// <summary>
        /// ȡBody
        /// </summary>
        /// <exception cref="ArgumentException">Ϊ0</exception>
        public float Mass
        {
            get { return mass; }
            set
            {
                if (value == 0)
                    throw new ArgumentException("Ϊ0", "value");

                mass = value;

                if (isStatic)
                    inverseMass = 0;
                else
                    inverseMass = 1f / value;
            }
        }

        /// <summary>
        /// ȡBody(1/Mass)
        /// </summary>
        public float InverseMass
        {
            get { return inverseMass; }
        }

        /// <summary>
        /// ȡǷĬΪfalse
        /// </summary>
        public bool IgnoreGravity = false;

        /// <summary>
        /// ʾBodyǷǹ̶ġ
        /// <para>ͱ߽ͨǹ̶ġ</para>
        /// </summary>
        public bool IsStatic
        {
            get { return isStatic; }
            set
            {
                isStatic = value;
                if (isStatic)
                {
                    inverseMass = 0;
                }
                else
                {
                    inverseMass = 1f / mass;
                }
            }
        }

        /// <summary>
        /// һθʱʩBodyϵ
        /// ÿθµú󶼻㣬ֵڸǰá
        /// ֻġ 
        /// </summary>
        /// <Value></Value>
        public Vector2 Force
        {
            get { return force; }
        }

        #region ʱ

        private Vector2 ds;
        private Vector2 dv = Vector2.Zero;

        /// <summary>
        /// ٶȡ
        /// </summary>
        private Vector2 acceleration = Vector2.Zero;

        #endregion

        /// <summary>
        /// ڲãٶȽл㡣
        /// </summary>
        /// <param name="dt">ʱ</param>
        internal void IntegrateVelocity(float dt)
        {
            // ٶ
            acceleration.X = force.X * inverseMass;
            acceleration.Y = force.Y * inverseMass;

            // ٶȵĸñٶʱĳ˻
            dv.X = acceleration.X * dt;
            dv.Y = acceleration.Y * dt;

            // һθʱٶ
            previousLinearVelocity = LinearVelocity;

            // 㵱ǰٶ
            LinearVelocity.X = previousLinearVelocity.X + dv.X;
            LinearVelocity.Y = previousLinearVelocity.Y + dv.Y;
        }

        /// <summary>
        /// ڲãλýл㡣
        /// </summary>
        /// <param name="dt">ʱ</param>
        internal void IntegratePosition(float dt)
        {
            // λõĸıٶȳʱ
            ds.X = LinearVelocity.X * dt;
            ds.Y = LinearVelocity.Y * dt;

            if (ds != Vector2.Zero)
            {
                // һθʱλ
                previousPosition = position;

                // 㵱ǰλ
                position.X = previousPosition.X + ds.X;
                position.Y = previousPosition.Y + ds.Y;
            }
        }

        /// <summary>
        /// Bodyʩһ
        /// </summary>
        /// <param name="amount"></param>
        public void ApplyForce(Vector2 amount)
        {
            force.X = force.X + amount.X;
            force.Y = force.Y + amount.Y;
        }

        /// <summary>
        /// ʩBodyϵ
        /// ÿθºҪ
        /// </summary>
        public void ClearForce()
        {
            force.X = 0;
            force.Y = 0;
        }

        /// <summary>
        /// ʩԳ
        /// </summary>
        /// <param name="impulse"></param>
        public void ApplyLinearImpulse(Vector2 impulse)
        {
            if (isStatic)
            {
                return;
            }

            dv.X = impulse.X * inverseMass;
            dv.Y = impulse.Y * inverseMass;

            LinearVelocity.X = dv.X + LinearVelocity.X;
            LinearVelocity.Y = dv.Y + LinearVelocity.Y;
        }
    }
}